// BMS FUNDAMENTAL EDIT LIBRARY Jwb_t@C
// by TEM
#ifndef BMSFEL_H
#define BMSFEL_H

// 36i2̃f[^ێBmsObjectƓ
#define BmsWord BmsObject
class BmsObject;
class BmsHeaderOne;
class BmsHeaderHash;
class BmsRegistArray;
class BmsBuffer;
class BmsChannel;
class BmsBar;
class BmsBms;

#define NULL_WORD         ((BmsWord *)(0))
#define NULL_OBJ          ((BmsObject *)(0))
#define NULL_HEADER_ONE   ((BmsHeaderOne *)(0))
#define NULL_HEADER_HASH  ((BmsHeaderHash *)(0))
#define NULL_REGIST_ARRAY ((BmsRegistArray *)(0))
#define NULL_BUFFER       ((BmsBuffer *)(0))
#define NULL_CHANNEL      ((BmsChannel *)(0))
#define NULL_BAR          ((BmsBar *)(0))
#define NULL_BMS          ((BmsBms *)(0))

enum {
  HEX36_MAX              = 36,
  BMS_OBJ_MAX            = 1296,
  BMS_WORD_MAX           = BMS_OBJ_MAX,
  BMS_BAR_MAX            = 1000,
  BAR_LENGTH_DEFAULT     = 384, // \
  CHANNEL_LENGTH_DEFAULT = BAR_LENGTH_DEFAULT * 10,
  CHANNEL_EXTEND_LENGTH  = BAR_LENGTH_DEFAULT * 10,
  HASH_TABLE_SIZE        = 79,
  HASH_MULTIPLIER        = 37,
};

//################################################
// }N`

// ꂼ̃`lɑ΂Ce[^
// "01"`lid`ljł1񂵂Ȃ
#define EACH_KIND_CHANNEL( first_channel, channel ) for ( BmsChannel *channel = first_channel; channel != NULL_CHANNEL; channel = channel->get_next() )
// "01"`lid`lj܂ߑS
#define EACH_CHANNEL( first_channel, channel ) for ( BmsChannel *_root = first_channel, *channel = first_channel; channel != NULL_CHANNEL; channel = ( channel->get_same_next() == NULL_CHANNEL ? ( _root = _root->get_next() ) : ( channel->get_same_next() ) ) )


//################################################
// 36if[^NX IuWF1
// \͍Ō'\0'vȂ
class BmsObject {
protected:
  char msb;
  char lsb;

public:
  //////////////////////////////////////////////////
  // RXgN^Q
  BmsObject();
  BmsObject( int x );
  BmsObject( const char *str );
  BmsObject( char msb, char lsb );
  // fXgN^
  ~BmsObject();

  //////////////////////////////////////////////////
  // setn
  void set( int x );
  void set( const char *str );
  void set( char msb, char lsb );

  //////////////////////////////////////////////////
  // getn
  int get_int() const;
  char get_msb() const;
  char get_lsb() const;
  char *get_str( char *str ) const;
  char *get_str_null( char *str ) const;
  void get_char( char *msb, char *lsb ) const;

  //////////////////////////////////////////////////
  // ZQ
  void operator ++();
  void operator ++( int none );
  void succ();
  void next();
  void add( int num );

  //////////////////////////////////////////////////
  // ZQ
  void operator --();
  void operator --( int none );
  void prev();
  void sub( int num );

  //////////////////////////////////////////////////
  // rQ

  //////////////////////////////////////////////////
  // ==n
  bool operator ==( int x ) const;
  bool operator !=( int x ) const;
  bool operator ==( char *str ) const;
  bool operator !=( char *str ) const;
  bool operator ==( BmsObject obj ) const;
  bool operator !=( BmsObject obj ) const;

  bool equal( int x ) const;
  bool equal( char *str ) const;
  bool equal( BmsObject obj ) const;
  bool equal( char msb, char lsb ) const;

  //////////////////////////////////////////////////
  // <= < >= >n
  bool operator <=( int x ) const;
  bool operator <=( char *str ) const;
  bool operator <=( BmsObject obj ) const;

  bool operator <( int x ) const;
  bool operator <( char *str ) const;
  bool operator <( BmsObject obj ) const;

  bool operator >=( int x ) const;
  bool operator >=( char *str ) const;
  bool operator >=( BmsObject obj ) const;

  bool operator >( int x ) const;
  bool operator >( char *str ) const;
  bool operator >( BmsObject obj ) const;

  //////////////////////////////////////////////////
  // rĂ̍(this - input)Ԃ
  int compare( int x ) const;
  int compare( char *str ) const;
  int compare( BmsObject obj ) const;
  int compare( char msb, char lsb ) const;

  //////////////////////////////////////////////////
  // ȍ~̓[eBeBn

};



//################################################
// wb_̃nbV̗vf
class BmsHeaderOne {
protected:
  char *key;
  char *value;
  BmsHeaderOne *next;

  void set_key( const char *key );
  void set_value_first( const char *value );

public:
  //////////////////////////////////////////////////
  // RXgN^Q
  // key͕K{ key̓e̓Rs[ĎOŗ̈mۂ
  BmsHeaderOne( const char *key );
  // value̓e̓Rs[ĎOŗ̈mۂ
  BmsHeaderOne( const char *key, const char *value );
  // fXgN^
  ~BmsHeaderOne();

  //////////////////////////////////////////////////
  // ẽIuWFĕԂ delete͌Ăяo
  BmsHeaderOne *clone() const;

  //////////////////////////////////////////////////
  // getn
  const char *get_key() const;
  const char *get_value() const;

  // setn
  // value̓e̓Rs[ĎOŗ̈mۂ ܂ł̕͏
  void set_value( const char *value );

  // Xgn
  BmsHeaderOne *get_next() const;
  void set_next( BmsHeaderOne *next );

  //////////////////////////////////////////////////
  // ȍ~̓[eBeBn

};



//################################################
// wb_̃nbV
class BmsHeaderHash {
protected:
  BmsHeaderOne *table[HASH_TABLE_SIZE];
  int count;

  // ̃nbVlvZ
  unsigned int hash( const char *str ) const;

  // ŌĂԌp֐
  void lookup( unsigned int hash_code, BmsHeaderOne *key, BmsHeaderOne **target ) const;
  void lookup( unsigned int hash_code, BmsHeaderOne *key, BmsHeaderOne **target, BmsHeaderOne **prev ) const;

public:
  //////////////////////////////////////////////////
  // RXgN^Q
  BmsHeaderHash();
  // fXgN^
  ~BmsHeaderHash();

  //////////////////////////////////////////////////
  // ẽIuWFĕԂ delete͌Ăяo
  BmsHeaderHash *clone() const;

  //////////////////////////////////////////////////
  // getn
  int get_count() const;

  //////////////////////////////////////////////////
  // vfi[
  // keyvaluë̗̓Rs[ĎOŗ̈mۂ ߂l͏㏑ǂ
  bool store( const char *key, const char *value );
  // delete̓Rei (:fetch_oneŎ擾̂nĂ͑ʖ)
  bool store( BmsHeaderOne *one );

  //////////////////////////////////////////////////
  // vfQƂ
  // vfL邩ǂ
  bool is_exist( const char *key ) const;
  // vfǂ
  bool is_empty( const char *key ) const;
  // keyƊ֘AÂĂ镶Ԃ ΋󕶎("")Ԃ
  const char *fetch_str( const char *key ) const;
  // vfIuWFԂ delete͈ڂȂ NULL_HEADER_ONEԂ
  BmsHeaderOne *fetch_one( const char *key ) const;
  
  //////////////////////////////////////////////////
  // vfHash폜

  // keyƈvvfnbV菜
  // keyɊ֘AtĂ镶*valuë̗(\ȗ̈悪Kv)ɏ
  bool take_str( const char *key, char *value );
  // Ɠ炪mۂ̈Ԃ̂deleteKv
  char *take_str( const char *key );
  // keyƊ֘AtĂvfnbV菜
  // ̗vfIuWFԂ delete͌Ăяo
  BmsHeaderOne *take_one( const char *key );

  // keyƈvvf폜trueԂ ݂ȂꍇfalseԂ
  bool delete_by_key( const char *key );

  // vfЂƂ菜Ԃ delete͌Ăяo
  BmsHeaderOne *shift();
  // *key*valuë̗(\ȗ̈悪Kv)ɏ vfꍇfalseԂ
  bool shift( char *key, char *value );

  //////////////////////////////////////////////////
  // gɂ ߂l͏
  int clear();

  //////////////////////////////////////////////////
  // ȍ~̓[eBeBn

};



//################################################
// WAVBMP̓o^ppNX
class BmsRegistArray {
protected:
  // #WAV01 sample.wav ̏ꍇ"WAV"̕ۑ
  char *name;
  char *list[BMS_OBJ_MAX];

public:

  //////////////////////////////////////////////////
  // RXgN^Q
  BmsRegistArray();
  // name̓Rs[ĎÖ̗ɕۑ
  BmsRegistArray( const char *name );
  // fXgN^
  ~BmsRegistArray();

  //////////////////////////////////////////////////
  // ẽIuWFĕԂ delete͌Ăяo
  BmsRegistArray *clone() const;

  //////////////////////////////////////////////////
  // getn
  const char *get_name() const;

  //////////////////////////////////////////////////
  // setn
  // name̓Rs[ĎOŗ̈mۂ
  void set_name( const char *name );

  //////////////////////////////////////////////////
  // i[
  // ̈̓Rs[ĎOŗ̈mۂ ߂l͏㏑ǂ
  bool overwrite( BmsWord nth, const char *value );
  // Oŗ̈mۂȂ valuedelete̓Rei
  bool overwrite_in( BmsWord nth, char *value );

  //////////////////////////////////////////////////
  // vfL邩ǂ
  bool is_exist( BmsWord nth ) const;
  // vfǂ
  bool is_empty( BmsWord nth ) const;

  //////////////////////////////////////////////////
  // vfQƂ delete͈ڂȂ
  // ꍇ""Ԃ
  const char *at( BmsWord nth ) const;

  //////////////////////////////////////////////////
  // vfo delete͌Ăяo
  char *take_at( BmsWord nth );

  //////////////////////////////////////////////////
  // vf폜 ߂l͎ۂɍ폜ǂ
  bool delete_at( BmsWord nth );

  //////////////////////////////////////////////////
  // vfЂƂ菜Ԃ delete͌Ăяo
  // *valuë̗(\ȗ̈悪Kv)ɏ vfꍇfalseԂ
  bool shift( BmsWord *nth, char *value );

  //////////////////////////////////////////////////
  // gɂ ߂l͏
  int clear();

  //////////////////////////////////////////////////
  // ȍ~̓[eBeBn

  // str̍\ɂĂ邩ǂ
  // #???@@ value ł [??? => name] [@@ => 00-ZZ] ǂ`FbN
  bool check_structure( const char *str ) const;

};



//################################################
// BmsObject̃Rei
class BmsBuffer {
protected:
  int length;
  BmsObject *obj_array;

public:
  //////////////////////////////////////////////////
  // RXgN^Q
  BmsBuffer( int length );
  // fXgN^
  ~BmsBuffer();

  //////////////////////////////////////////////////
  // getn
  int get_length() const;
  int get_count() const;

  //////////////////////////////////////////////////
  // IuWF񑀍n

  // Q nthlengthȏȂ"00"̃IuWFԂ
  BmsObject at( int nth ) const;

  // ㏑
  // nth  length ȏ̒lƉ"00"̃IuWFԂ
  // ߂l͏㏑OɃIuWF
  BmsObject overwrite( int nth, BmsObject obj );

  // 폜 "00"̃IuWFl߂
  // ߂l͍폜̂"00"ȊÕIuWFǂ
  bool delete_at( int nth );
  // SĂɑ΂delete_at() ߂l͎ۂdelete
  int clear();

  //////////////////////////////////////////////////
  // IuWF𕶎ɕϊ ߂l͎ۂɕϊ̑傫
  // |C^̐ length * 2 傫ȗ̈pӂ邱
  int to_str( char *str ) const;
  // Ō'\0't length * 2 + 1 傫ȗ̈pӂ邱
  // ߂l͓̗͂̈ւ̃|C^
  int to_str_null( char *str ) const;

  //////////////////////////////////////////////////
  // IuWFɕϊ ߂l͕ϊ̒
  // Ō'\0'Kv
  int input_str( char *str );
  // n = ̒
  int input_n_str( int n, char *str );

  //////////////////////////////////////////////////
  // IuWF nthwł̏ꏊ Cvbg"00"Ȃ獡܂ł̂L
  //  : "FF00FF00".marge( "0000DDDD" ) => "FF00DDDD"
  // ߂l͏㏑ďIuWF("00"͊܂܂Ȃ)
  // input_bufferdelete͈ڂȂ
  int merge( BmsBuffer *input_buffer );
  int merge( int nth, BmsBuffer *input_buffer );
  // input_bufferdelete
  int push_in( BmsBuffer *input_buffer );
  int push_in( int nth, BmsBuffer *input_buffer );

  //////////////////////////////////////////////////
  // IuWF؂oăRs[ ̕BmsBufferԂ neŵdelete͌Ăяo
  // fromto(܂)܂ fromtoNULL_BUFFERԂ
  BmsBuffer *slice_to( int from, int to ) const;
  // fromlength̒ length0菬NULL_BUFFERԂ
  // fromRs[length傫ƉRs[ȂBmsBufferԂ
  BmsBuffer *slice_length( int from, int length ) const;

};


//################################################
// `l1
class BmsChannel : public BmsBuffer {
protected:
  BmsWord channel_number;
  //////////////////////////////////////////////////
  // `lp`Xg\AʎĝBGM`l
  // fXgN^łȍ~̃XgŜŒ  dlύX邩
  BmsChannel *same_next;
  //////////////////////////////////////////////////
  // `lp`Xg
  BmsChannel *next;

public:
  //////////////////////////////////////////////////
  // RXgN^Q
  // w肵̃̕IuWFƃ`lio[
  // `lio["00"ŏ
  BmsChannel();
  BmsChannel( BmsWord channel_word );

public:
  // fXgN^
  ~BmsChannel();

  //////////////////////////////////////////////////
  // `lpXg\֐
  // Ⴄ`lȂo^falseԂ
  bool set_same_next( BmsChannel *same_next );
  BmsChannel *get_same_next() const;

  //////////////////////////////////////////////////
  // `lp`Xg
  void set_next( BmsChannel *next );
  BmsChannel *get_next() const;

  //////////////////////////////////////////////////
  // setn
  void set_channel_number( BmsWord channel_word );

  //////////////////////////////////////////////////
  // getn
  BmsWord get_channel_number() const;

  //////////////////////////////////////////////////
  // ȍ~̓[eBeBn

  //////////////////////////////////////////////////
  // BmsBuffer̊֐̂length𒴂zg֐
  BmsObject overwrite( int nth, BmsObject obj );
  int merge( BmsBuffer *input_buffer );
  int merge( int nth, BmsBuffer *input_buffer );
  int push_in( BmsBuffer *input_buffer );
  int push_in( int nth, BmsBuffer *input_buffer );

  // z(BAR_LENGTH_DEFAULT * 10 * n > nth)g֐
  // ߂l͊glength
  int extend_array_over( int nth );
  
};



//################################################
// 1 ǗĂȂ
class BmsBar {
protected:
  int length;

public:

  //////////////////////////////////////////////////
  // RXgN^Q
  // Ȃ̏ꍇ̃ftHg̒lBAR_LENGTH_DEFAULT(= 192 ?)
  BmsBar();
  // ʏ̒BAR_LENGTH_DEFAULT(= 192 ?)Ƃꍇ
  BmsBar( int length );
  // ʏ̒1.0Ƃꍇ
  BmsBar( double length );
  // Ldouble̕\
  BmsBar( char *length_str );
  // fXgN^
  ~BmsBar();

  //////////////////////////////////////////////////
  // ߒԂ
  int get_length_int() const;
  double get_length_double() const;

  //////////////////////////////////////////////////
  // ߒύX
  void set( int length );
  void set( double length );
  void set( char *length_str );

  //////////////////////////////////////////////////
  // ȍ~̓[eBeBn

};



//################################################
// BMS̗vf̑SĂǗNX BMSt@C̒ۉ
class BmsBms {
protected:
  BmsHeaderHash *headers;
  BmsRegistArray *wavs;
  BmsRegistArray *bmps;
  int channel_count;
  BmsChannel *first_channel;
  BmsBar bars[BMS_BAR_MAX];

public:
  //////////////////////////////////////////////////
  // RXgN^Q
  BmsBms();
  // fXgN^
  ~BmsBms();

  //////////////////////////////////////////////////
  // wb_n delete͈ڂȂ
  BmsHeaderHash *get_headers() const;
  BmsRegistArray *get_wavs() const;
  BmsRegistArray *get_bmps() const;


  //################################################
  // ߑ


  // ̏߂`l̂ǂ̈ʒuɂ̂ ߂l̓`l̈ʒu
  int get_channel_position( int nth ) const;

  // IuWF݂BmsChannel̍ő̈ʒu擾
  int get_max_position() const;

  // IuWF݂ő̏ߐ擾
  int get_max_bar() const;

  // ȍ~nthBMS_BAR_MAX𒴂length 0̃IuWFNgԂ

  // Q
  BmsBar bar_at( int nth ) const;

  // in_barŒu ߂l͍܂ł
  BmsBar overwrite_bar_at( int nth, BmsBar in_bar );

  // } ȍ~̏߂1 ߂l999ߖ delete͌Ăяo
  BmsBar insert_bar_at( int nth, BmsBar in_bar );

  //  ̏߂BAR_LENGTH_DEFAULTɂȂ ߂l͏IuWFNg
  BmsBar erase_bar_at( int nth );

  //  ȍ~̏߂l߂ ߂l͏IuWFNg
  BmsBar delete_bar_at( int nth );

  // ߂Sċɂ
  void clear_bar();


  //################################################
  // `ln

  // `l邩
  int get_channel_count() const;

  //////////////////////////////////////////////////
  // getn
  // delete͈ڂȂ
  // Xgŏ̃`lԂ
  BmsChannel *get_first_channel() const;
  // `lio[Ɉv`lIuWFNgԂ
  BmsChannel *get_channel( BmsWord channel_word ) const;

  //////////////////////////////////////////////////
  // setn
  // `lIuWFۑB
  // ɓ`lio[̃IuWFNgꍇ
  // ̓IuWFƓւāA߂lƂĂԂ
  // delete̓Rei
  BmsChannel *set_channel( BmsChannel *input_channel );

  // `lꍇ㏑āAȑÔdelete
  // set_channelƓ ߂l͈ȑÔǂ
  // delete̓Rei
  bool overwrite_channel( BmsChannel *input_channel );

protected:
  // perv->next  input ɂinput->next  next ɂ
  // prev == NULL_CHANNEL ̏ꍇfirst_channel  input 
  void insert_list_channel( BmsChannel *prev, BmsChannel *next, BmsChannel *input );

public:
  //////////////////////////////////////////////////
  // deleten
  // oČĂяoɕԂ delete͌Ăяo
  BmsChannel *take_channel( BmsWord channel_word );
  // deletes
  bool delete_channel( BmsWord channel_word );

protected:
  // perv->next  next ɂtake->next  NULL_CHANNEL ɂ
  // prev == NULL_CHANNEL ̏ꍇfirst_channel  next 
  // take == NULL_CHANNEL ̏ꍇ͉Ȃ ߂ltakeƓ
  BmsChannel *take_list_channel( BmsChannel *prev, BmsChannel *next, BmsChannel *take );

public:
  //////////////////////////////////////////////////
  // gɂ ߂l͏
  int clear_channel();

  //////////////////////////////////////////////////
  // ȍ~̓[eBeBn

  // nthߖڂchannel_word̃`lɑ΂đ삷
  // channel_word̃`l܂ꍇ
  // Rs[Ď擾 delete͌Ăяo
  BmsBuffer *pop_out( int nth, BmsWord channel_word ) ;
  // ͂ď㏑ delete̓Rei ߂l͏㏑ꂽIuWF
  int push_in( int nth, BmsWord channel_word, BmsBuffer *input_buffer );

  // nth߂channel_word`lstr 
  int input_str( int nth, BmsWord channel_word, char *str );
  // n = ̒
  int input_n_str( int nth, BmsWord channel_word, int n, char *str );

  // nth߂channel_word`l𕶎o
  // IuWF𕶎ɕϊ ߂l͎ۂɕϊ̑傫 `lꍇ-1Ԃ
  // |C^̐ length * 2 傫ȗ̈pӂ邱
  int to_str( int nth, BmsWord channel_word, char *str ) const;
  // Ō'\0't length * 2 + 1 傫ȗ̈pӂ邱
  // ߂l͓̗͂̈ւ̃|C^
  int to_str_null( int nth, BmsWord channel_word, char *str ) const;

};



//################################################
// BMS͊֐
namespace BmsLexer {
  //////////////////////////////////////////////////
  // path̃t@CJĉ͂BmsBmsԂ
  // ߂l͐^AsȂU
  bool read_file( char *path, BmsBms **bms_p );

  //////////////////////////////////////////////////
  // path̃t@CJĂɏ
  // ߂l͐^AsȂU
  bool write_file( char *path, BmsBms *bms );
  
}



//################################################
// 낢֗Ȃ
namespace BmsUtil {

  //////////////////////////////////////////////////
  // int36i̕ɕϊ(input : 0`35)
  char int_to_hex36( int x );

  //////////////////////////////////////////////////
  // 36i̕intɕϊ
  int hex36_to_int( char *str );
  int hex36_to_int( char msb, char lsb );

  //////////////////////////////////////////////////
  // ő񐔂߂
  int gcd( int x, int y );

  //////////////////////////////////////////////////
  // 啶
  void str2upper( char *str );

  //////////////////////////////////////////////////
  // Rs[ė̈m
  char *str_new_cpy( const char *str, bool to_upper_flag );
}

#endif // BMSFEL_H
